JAS (1)                 USER COMMANDS                           JAS(1)

NAME

        jas  -  Joe's assembler - the SOZOBON(X) assembler


SYNOPSIS

        jas [options] [-o <object file>] <source file>

        jas [options] <inputfile> [<outputfile>[ <errorfile>]]

        jas [-VvhN8lu] [-L<n>] [-s <dir>] <source file>
                   [[-o ]<object file>] [[-E]<errorfile>]


DESCRIPTION            

      The  jas  assembler is designed for compatibility with the Alcyon
      assembler.   It   doesn't  provide  many  features  the  assembly
      language  programmer  might want, but is intended more for use by
      a  compiler  front-end.  Jas generally produces smaller code than
      the  Alcyon  assembler  because  it  is  smarter about generating
      short  branch  instructions.   Also,  jas uses no temporary files
      and runs quite a bit faster than Alcyon.  

      Jas works as a filter on the input file (68000 assembler sorce code);
      if no output file is given, the generated object is written to a file
      with same name but suffix '.o'. You can use '-' for input file and
      output file, too. Jas will read then from stdin, and/or write to
      stdout.

      Pseudo opcodes:

      structure
        .text
        .bss
        .data
        .end

      symbols
        .comm <symbol>,<size>  (common symbol with size <size> in Bytes
                                  or 0 for extern definition; variable)
        .globl <symbol>        (global symbol; text or variable)

        <symbol>:              (this is symbol <symbol>; definition)

        Undefined but used symbols are extern globals, defined symbols
        are local by default. 

      define data
        .dc.S <value> [<value>, ...]    e.g.: .dc.l 0, 0
                                              .dc.b "this is a string",0
        .ds.S <count>                   e.g.: .ds.w 2

        
      others:
        .even   align following statements to even address
        .equ <macro> <text>
        .org <address>

OPTIONS

      Some  of  the command line options are accepted for compatibility
      with  the  Alcyon  assembler,  but  are  actually  ignored.   The
      following command line options are supported: 


        --version
        -V      (Version)
           Print a version message and exit.  

        -v      (verbose)
           Print a short version info, the size of the generated object
           module and some information about optimizing branches and jumps.
           
        -h      (help)
           Print the usage message and exit.

        -N
           Don't optimize (esp. don't generate 'short' branch 
           instructions).  

        -8      (short names)
           Don't generate SozobonX symbols for names longer than 8
           characters, but cut them to a length of 8.

        -L<n>   (Local symbols) 
           By  default,  no local symbols are placed in the symbol
           table  of  the output. This option instructs jas to put
           all  symbols  into  the  symbol  table  if  n  is  2 or
           greater.  If  the  option '-L1' is given, symbols whose
           name  doesn't  start with 'L' ot 'T' are written to the
           symbol table.  

        -o <file> 

           By default, the assembler replaces the input file's extension
           ('.s') with '.o' to form the name of the output.  This option
           can be used to write the output to any file. 

        ignored for compatibility:

        -l 

        -u 

        -s <dir> 



ENVIRONMENT

        If $STDERR is present, stderr handle (2) is used for diagnostic
        output; if not and no ARGV was used it will be CONsole handle (-1).


BUGREPORTS

        Current maintainer is Thorsten Roskowetz. Please send bugreports
        using the 'bugform' to
        rtroskow@jupiter.rz.Uni-Osnabrueck.DE (Thorsten Roskowetz)


SEE ALSO
        cc(1), make(1), nm(1)
